Index: src/Actions/Action.cpp
===================================================================
--- src/Actions/Action.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Actions/Action.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -10,6 +10,12 @@
 #include "Actions/Action.hpp"
 #include "Actions/ActionRegistry.hpp"
+#include "Actions/ActionHistory.hpp"
+#include "Helpers/MemDebug.hpp"
 
 using namespace std;
+
+// An empty state to indicate success
+Action::state_ptr Action::success = Action::state_ptr(Memory::ignore(new ActionState()));
+Action::state_ptr Action::failure = Action::state_ptr(Memory::ignore(new ActionState()));
 
 Action::Action(std::string _name,bool _doRegister) :
@@ -17,5 +23,5 @@
 {
   if(_doRegister){
-    ActionRegistry::getRegistry()->registerAction(this);
+    ActionRegistry::getInstance().registerAction(this);
   }
 }
@@ -27,2 +33,31 @@
   return name;
 }
+
+void Action::call(){
+  if(!isActive()){
+    return;
+  }
+  // forward to private virtual
+  state_ptr state = performCall();
+  if(shouldUndo() && state != failure){
+    if(canUndo()){
+      ActionHistory::getInstance().addElement(this,state);
+    }
+    else{
+      ActionHistory::getInstance().clear();
+    }
+  }
+}
+Action::state_ptr Action::undo(state_ptr _state) {
+  // forward to private virtual
+  return performUndo(_state);
+}
+Action::state_ptr Action::redo(state_ptr _state) {
+  // forward to private virtual
+  return performRedo(_state);
+}
+
+
+bool Action::isActive(){
+  return true;
+}
Index: src/Actions/Action.hpp
===================================================================
--- src/Actions/Action.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Actions/Action.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -10,4 +10,237 @@
 
 #include <string>
+#include <boost/shared_ptr.hpp>
+
+// forward declaration
+
+class ActionState;
+class ActionSequence;
+
+/**
+ * @file
+ * <H1> Action Howto </H1>
+ *
+ * <H2> Introduction </H2>
+ *
+ * Actions are used in object oriented design as a replacement for callback functions.
+ * In most ways Actions can be used in the same way that callbacks were used in non
+ * OO-Systems, but can contain support for several extra mechanism such as undo/redo
+ * or progress indicators.
+ *
+ * The main purpose of an action class is to contain small procedures, that can be repeatedly
+ * called. These procedures can also be stored, passed around, so that the execution of an
+ * action can happen quite far away from the place of creation. For a detailed description of
+ * the Action pattern see GOF:1996.
+ *
+ * <H3> How to use an action </H3>
+ *
+ * The process of using an action is as easy as calling the call() method of the action. The
+ * action will then do whatever it is supposed to do. If it is an action that can be undone, it
+ * will also register itself in the history to make itself available for undo. To undo the last
+ * action, you can either use the undoLast() method inside the ActionHistory class or call the
+ * UndoAction also provided by the ActionHistory. If an action was undone it will be available for
+ * redo, using the redoLast() method of the ActionHistory or the RedoAction also provided by this
+ * class. To check whether undo/redo is available at any moment you can use the hasUndo() or
+ * hasRedo() method respectively.
+ *
+ * Actions can be set to be active or inactive. If an action is set to inactive it is signaling, that
+ * some condition necessary for this action to be executed is not currently met. For example the
+ * UndoAction will set itself to inactive, when there is no action at that time that can be undone.
+ * Using call() on an inactive Action results in a no-op. You can query the state of an action using
+ * the isActive() method.
+ *
+ * The undo capabilities of actions come in three types as signaled by two boolean flags (one
+ * combination of these flags is left empty as can be seen later).
+ * <ul>
+ * <li/> The first flag indicates if the undo mechanism for this action should be considered at all, i.e.
+ *   if the state of the application changes in a way that needs to be reverted. Actions that should
+ *   consider the undo mechanism are for example adding a molecule, moving atoms, changing
+ *   the name of a molecule etc. Changing the View-Area on the other hand should be an action that
+ *   does not consider the undo mechanism. This flag can be queried using the shouldUndo() method.
+ *
+ * <li/> The second flag indicates whether the changes can be undo for this action. If this flag is true
+ *   the action will be made available for undo using the ActionHistory class and the actions of this
+ *   class. If this flag is false while the shoudlUndo() flag is true this means that this action
+ *   changes the state of the application changes in a way that cannot be undone, but might cause
+ *   the undo of previous actions to fail. In this case the whole History is cleared, as to keep
+ *   the state of the application intact by avoiding dangerous undos. This flag can be queried
+ *   using the canUndo() method.
+ *</ul>
+ *
+ * Each action has a name, that can be used to identify it throughout the run of the application.
+ * This name can be retrieved using the getName() method. Most actions also register themselves with
+ * a global structure, called the ActionRegistry. Actions that register themselves need to have a
+ * unique name for the whole application. If the name is known these actions can be retrieved from
+ * the registry by their name and then be used as normal.
+ *
+ * <H2> Building your own actions </H2>
+ *
+ * Building actions is fairly easy. Simply derive from the abstract Action base class and implement
+ * the virtual methods. The main code that needs to be executed upon call() should be implemented in
+ * the performCall() method. You should also indicate whether the action supports undo by implementing
+ * the shouldUndo() and canUndo() methods to return the appropriate flags.
+ *
+ * The constructor of your derived class also needs to call the Base constructor, passing it the
+ * name of the Action and a flag indicating whether this action should be made available in the
+ * registry. WARNING: Do not use the virtual getName() method of the derived action to provide the
+ * constructor with the name, even if you overloaded this method to return a constant. Doing this
+ * will most likely not do what you think it does (see: http://www.parashift.com/c++-faq-lite/strange-inheritance.html#faq-23.5
+ * if you want to know why this wont work)
+ *
+ * <H3> Interfacing your Action with the Undo mechanism </H3>
+ *
+ * The performX() methods need to comply to a simple standard to allow for undo and redo. The first
+ * convention in this standard concerns the return type. All methods that handle calling, undoing
+ * or redoing return an object of Action::state_ptr. This is a smart pointer to a State object, that
+ * can be used to store state information that is needed by your action for later redo. A rename
+ * Action for example would need to store which object has been renamed and what the old name was.
+ * A move Action on the other hand would need to store the object that has been moved as well as the
+ * old position. If your Action does not need to store any kind of information for redo you can
+ * simply return Action::success and skip the rest of this paragraph. If your action has been
+ * abborted you can return Action::failure, which indicates to the history mechanism that this
+ * action should not be stored.
+ *
+ * If your Action needs any kind of information to undo its execution, you need to store this
+ * information in the state that is returned by the performCall() method. Since no assumptions
+ * can be made on the type or amount of information the ActionState base class is left empty.
+ * To use this class you need to derive a YourActionState class from the ActionState base class
+ * adding your data fields and accessor functions. Upon undo the ActionState object produced
+ * by the corresponding performCall() is then passed to the performUndo() method which should
+ * typecast the ActionState to the appropriate sub class, undo all the changes and produce
+ * a State object that can be used to redo the action if neccessary. This new state object is
+ * then used if the redo mechanism is invoked and passed to the performRedo() function, which
+ * again produces a State that can be used for performUndo().
+ *
+ * <H3> Outline of the implementation of Actions </H3>
+ *
+ * To sum up the actions necessary to build actions here is a brief outline of things methioned
+ * in the last paragraphs:
+ *
+ * <H4> Basics </H4>
+ *
+ * <ul>
+ *  <li/> derive YourAction from Action
+ *  <li/> pass name and flag for registry to the base constructor
+ *  <li/> implement performCall(), performUndo(), performRedo()
+ *  <li/> implement the functions that return the flags for the undo mechanism
+ *  <li/> Derive YourActionState from ActionState as necessary
+ * </ul>
+ *
+ * <H4> Implementing performX() methods </H4>
+ *
+ * <ul>
+ *  <li/> performCall():
+ *  <ul>
+ *   <li/> do whatever is needed to make the action work
+ *   <li/> if the action was abborted return Action::failure
+ *   <li/> if the action needs to save a state return a custom state object
+ *   <li/> otherwise return Action::success
+ *  </ul>
+ *  <li/> performUndo():
+ *  <ul>
+ *   <li/> typecast the ActionState pointer to a Pointer to YourActionState if necessary
+ *   <li/> undo the action using the information from the state
+ *   <li/> produce a new state that can be used for redoing and return it
+ *  </ul>
+ *  <li/> performRedo():
+ *  <ul>
+ *   <li/> take the ActionState produced by performUndo and typecast it to a pointer to YourActionState if necessary
+ *   <li/> redo the undone action using the information from the state
+ *   <li/> produce a new state that can be used by performUndo() and return it
+ *  </ul>
+ * </ul>
+ *
+ * <H2> Advanced techniques </H2>
+ *
+ * <H3> Predefined Actions </H3>
+ *
+ * To make construction of actions easy there are some predefined actions. Namely these are
+ * the MethodAction and the ErrorAction.
+ *
+ * The method action can be used to turn any function with empty arguments and return type void
+ * into an action (also works for functors with those types). Simply pass the constructor for the
+ * MethodAction a name to use for this action, the function to call inside the performCall()
+ * method and a flag indicating if this action should be made retrievable inside the registry
+ * (default is true). MethodActions always report themselves as changing the state of the
+ * application but cannot be undone. i.e. calling MethodActions will always cause the ActionHistory
+ * to be cleared.
+ *
+ * ErrorActions can be used to produce a short message using the Log() << Verbose() mechanism of
+ * the molecuilder. Simply pass the constructor a name for the action, the message to show upon
+ * calling this action and the flag for the registry (default is again true). Error action
+ * report that they do not change the state of the application and are therefore not considered
+ * for undo.
+ *
+ * <H3> Sequences of Actions and MakroActions </H3>
+ *
+ * <H4> Building sequences of Actions </H4>
+ *
+ * Actions can be chained to sequences using the ActionSequence class. Once an ActionSequence is
+ * constructed it will be initially empty. Any Actions can then be added to the sequence using the
+ * addAction() method of the ActionSequence class. The last added action can be removed using the
+ * removeLastAction() method. If the construction of the sequence is done, you can use the
+ * callAll() method. Each action called this way will register itself with the History to allow
+ * separate undo of all actions in the sequence.
+ *
+ * <H4> Building larger Actions from simple ones </H4>
+ *
+ * Using the pre-defined class MakroAction it is possible to construct bigger actions from a sequence
+ * of smaller ones. For this you first have to build a sequence of the actions using the ActionSequence
+ * as described above. Then you can construct a MakroAction passing it a name, the sequence to use
+ * and as usual a flag for the registry. You can then simply call the complete action-sequence through
+ * this makro action using the normal interface. Other than with the direct use of the action sequence
+ * only the complete MakroAction is registered inside the history, i.e. the complete sequence can be
+ * undone at once. Also there are a few caveats you have to take care of when using the MakroAction:
+ * <ul>
+ *  <li/> All Actions as well as the sequence should exclusively belong to the MakroAction. This
+ *        especially means, that the destruction of these objects should be handled by the MakroAction.
+ *  <li/> none of the Actions inside the MakroAction should be registered with the registry, since the
+ *        registry also assumes sole ownership of the actions.
+ *  <li/> Do not remove or add actions from the sequence once the MakroAction has been constructed, since this
+ *        might brake important assumptions for the undo/redo mechanism
+ * </ul>
+ *
+ * <H3> Special kinds of Actions </H3>
+ *
+ * To make the usage of Actions more versatile there are two special kinds of actions defined,
+ * that contain special mechanisms. These are defined inside the class Process, for actions that
+ * take some time and indicate their own progress, and in the class Calculations for actions that
+ * have a retrievable result.
+ *
+ * <H4> Processes </H4>
+ *
+ * Processes are Actions that might take some time and therefore contain special mechanisms
+ * to indicate their progress to the user. If you want to implement a process you can follow the
+ * guidelines for implementing actions. In addition to the normal Action constructor parameters,
+ * you also need to define the number of steps the process takes to finish (use 0 if that number is
+ * not known upon construction). At the beginning of your process you then simply call start() to
+ * indicate that the process is taking up its work. You might also want to set the number of steps it
+ * needs to finish, if it has changed since the last invocation/construction. You can use the
+ * setMaxSteps() method for this. Then after each finished step of calulation simply call step(),
+ * to let the indicators know that it should update itself. If the number of steps is not known
+ * at the time of calculation, you should make sure the maxSteps field is set to 0, either through
+ * the constructor or by using setMaxSteps(0). Indicators are required to handle both processes that
+ * know the number of steps needed as well as processes that cannot predict when they will be finished.
+ * Once your calculation is done call stop() to let every indicator know that the process is done with
+ * the work and to let the user know.
+ *
+ * Indicators that want to know about processes need to implement the Observer class with all the
+ * methods defined there. They can then globally sign on to all processes using the static
+ * Process::AddObserver() method and remove themselves using the Process::RemoveObserver()
+ * methods. When a process starts it will take care that the notification for this process
+ * is invoked at the right time. Indicators should not try to observe a single process, but rather
+ * be ready to observe the status of any kind of process using the methods described here.
+ *
+ * <H4> Calculations </H4>
+ *
+ * Calculations are special Actions that also return a result when called. Calculations are
+ * always derived from Process, so that the progress of a calculation can be shown. Also
+ * Calculations should not contain side-effects and not consider the undo mechanism.
+ * When a Calculation is called using the Action mechanism this will cause it to calculate
+ * the result and make it available using the getResult() method. Another way to have a Calculation
+ * produce a result is by using the function-call operator. When this operator is used, the Calculation
+ * will try to return a previously calculated and cached result and only do any actuall calculations
+ * when no such result is available. You can delete the cached result using the reset() method.
+ */
 
 /**
@@ -16,24 +249,133 @@
  * Actions describe something that has to be done.
  * Actions can be passed around, stored, performed and undone (Command-Pattern).
- *
- * TODO: Add queues of actions that have been performed to allow easy implementation of multiple-step undo
  */
 class Action
 {
-protected:
+friend class ActionSequence;
+friend class ActionHistory;
 public:
+
+  /**
+   * This type is used to store pointers to ActionStates while allowing multiple ownership
+   */
+  typedef boost::shared_ptr<ActionState> state_ptr;
+
+  /**
+   * Standard constructor of Action Base class
+   *
+   * All Actions need to have a name. The second flag indicates, whether the action should
+   * be registered with the ActionRegistry. If the Action is registered the name of the
+   * Action needs to be unique for all Actions that are registered.
+   */
   Action(std::string _name,bool _doRegister=true);
   virtual ~Action();
 
-  virtual void call()=0;
-  virtual void undo()=0;
+  /**
+   * This method is used to call an action. The basic operations for the Action
+   * are carried out and if necessary/possible the Action is added to the History
+   * to allow for undo of this action.
+   *
+   * If the call needs to undone you have to use the History, to avoid destroying
+   * invariants used by the History.
+   */
+  void call();
+
+  /**
+   * This method provides a flag that indicates if an undo mechanism is implemented
+   * for this Action. If this is true, and this action was called last, you can
+   * use the History to undo this action.
+   */
   virtual bool canUndo()=0;
-  //virtual bool shouldUndo()=0;
-
+
+  /**
+   * This method provides a flag, that indicates if the Action changes the state of
+   * the application in a way that needs to be undone for the History to work.
+   *
+   * If this is false the Action will not be added to the History upon calling. However
+   * Actions called before this one will still be available for undo.
+   */
+  virtual bool shouldUndo()=0;
+
+  /**
+   * Indicates whether the Action can do it's work at the moment. If this
+   * is false calling the action will result in a no-op.
+   */
+  virtual bool isActive();
+
+  /**
+   * Returns the name of the Action.
+   */
   virtual const std::string getName();
 
+protected:
+  /**
+   * This method is called by the History, when an undo is performed. It is
+   * provided with the corresponding state produced by the performCall or
+   * performRedo method and needs to provide a state that can be used for redo.
+   */
+  state_ptr undo(state_ptr);
+
+  /**
+   * This method is called by the Histor, when a redo is performed. It is
+   * provided with the corresponding state produced by the undo method and
+   * needs to produce a State that can then be used for another undo.
+   */
+  state_ptr redo(state_ptr);
+
+  /**
+   * This special state can be used to indicate that the Action was successfull
+   * without providing a special state. Use this if your Action does not need
+   * a speciallized state.
+   */
+  static state_ptr success;
+
+  /**
+   * This special state can be returned, to indicate that the action could not do it's
+   * work, was abborted by the user etc. If you return this state make sure to transactionize
+   * your Actions and unroll the complete transaction before this is returned.
+   */
+  static state_ptr failure;
+
 private:
+  /**
+   * This is called internally when the call is being done. Implement this method to do the actuall
+   * work of the Action. Implement this in your Derived classes. Needs to return a state that can be
+   * used to undo the action.
+   */
+  virtual state_ptr performCall()=0;
+
+  /**
+   * This is called internally when the undo process is chosen. This Method should use the state
+   * produced by the performCall method to return the state of the application to the state
+   * it had before the Action.
+   */
+  virtual state_ptr performUndo(state_ptr)=0;
+
+  /**
+   * This is called internally when the redo process is chosen. This method shoudl use the state
+   * produced by the performUndo method to return the application to the state it should have after
+   * the action.
+   *
+   * Often this method can be implement to re-use the performCall method. However if user interaction
+   * or further parameters are needed, those should be taken from the state and not query the user
+   * again.
+   */
+  virtual state_ptr performRedo(state_ptr)=0;
+
   std::string name;
 };
 
+/**
+ * This class can be used by actions to save the state.
+ *
+ * It is implementing a memento pattern. The base class is completely empty,
+ * since no general state internals can be given. The Action performing
+ * the Undo should downcast to the apropriate type.
+ */
+class ActionState{
+public:
+  ActionState(){}
+  virtual ~ActionState(){}
+};
+
 #endif /* ACTION_H_ */
Index: src/Actions/ActionHistory.cpp
===================================================================
--- src/Actions/ActionHistory.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/ActionHistory.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,133 @@
+/*
+ * ActionHistory.cpp
+ *
+ *  Created on: Mar 25, 2010
+ *      Author: crueger
+ */
+
+#include "ActionHistory.hpp"
+
+#include <iostream>
+
+#include "Patterns/Singleton_impl.hpp"
+#include "Helpers/Assert.hpp"
+#include "Helpers/MemDebug.hpp"
+
+using namespace std;
+
+ActionHistory::ActionHistory()
+{}
+
+ActionHistory::~ActionHistory()
+{}
+
+void ActionHistory::undoLast(){
+  ASSERT(history.size(),"Undo performed when the undo-queue was empty");
+  HistoryElement elem = history.back();
+  history.pop_back();
+  Action::state_ptr newState = elem.action->undo(elem.state);
+  yrotsih.push_back(HistoryElement(elem.action,newState));
+}
+void ActionHistory::redoLast(){
+  ASSERT(yrotsih.size(),"Redo performed when the redo-queue was empty");
+  HistoryElement elem = yrotsih.back();
+  yrotsih.pop_back();
+  Action::state_ptr oldState = elem.action->redo(elem.state);
+  history.push_back(HistoryElement(elem.action,oldState));
+}
+
+bool ActionHistory::hasUndo(){
+  return history.size()>0;
+}
+
+bool ActionHistory::hasRedo(){
+  return yrotsih.size()>0;
+}
+
+void ActionHistory::addElement(Action* action,Action::state_ptr state){
+  yrotsih.clear();
+  history.push_back(HistoryElement(action,state));
+}
+
+void ActionHistory::clear(){
+  history.clear();
+  yrotsih.clear();
+}
+
+void ActionHistory::init(){
+  ActionHistory *hist = new ActionHistory();
+  setInstance(hist);
+  new UndoAction(hist);
+  new RedoAction(hist);
+}
+
+CONSTRUCT_SINGLETON(ActionHistory)
+
+/****************** Contained actions *******************/
+ActionHistory::UndoAction::UndoAction(ActionHistory *_hist) :
+  Action("Undo"),
+  hist(_hist)
+{}
+
+ActionHistory::UndoAction::~UndoAction(){}
+
+bool ActionHistory::UndoAction::canUndo(){
+  return false;
+}
+
+bool ActionHistory::UndoAction::shouldUndo(){
+  return false;
+}
+
+bool ActionHistory::UndoAction::isActive(){
+  return hist->hasUndo();
+}
+
+Action::state_ptr ActionHistory::UndoAction::performCall(){
+  hist->undoLast();
+  return Action::success;
+}
+
+Action::state_ptr ActionHistory::UndoAction::performUndo(Action::state_ptr){
+  ASSERT(0,"Cannot undo an undo (should use redo for this");
+  return Action::success;
+}
+
+Action::state_ptr ActionHistory::UndoAction::performRedo(Action::state_ptr){
+  ASSERT(0,"Cannot redo an undo");
+  return Action::success;
+}
+
+ActionHistory::RedoAction::RedoAction(ActionHistory *_hist) :
+    Action("Redo"),
+    hist(_hist)
+{}
+
+ActionHistory::RedoAction::~RedoAction(){}
+
+bool ActionHistory::RedoAction::canUndo(){
+  return false;
+}
+
+bool ActionHistory::RedoAction::shouldUndo(){
+  return false;
+}
+
+bool ActionHistory::RedoAction::isActive(){
+  return hist->hasRedo();
+}
+
+Action::state_ptr ActionHistory::RedoAction::performCall(){
+  hist->redoLast();
+  return Action::success;
+}
+
+Action::state_ptr ActionHistory::RedoAction::performUndo(Action::state_ptr){
+  ASSERT(0,"Cannot undo a redo (should use undo for this");
+  return Action::success;
+}
+
+Action::state_ptr ActionHistory::RedoAction::performRedo(Action::state_ptr){
+  ASSERT(0,"Cannot redo a redo");
+  return Action::success;
+}
Index: src/Actions/ActionHistory.hpp
===================================================================
--- src/Actions/ActionHistory.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/ActionHistory.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,92 @@
+/*
+ * ActionHistory.hpp
+ *
+ *  Created on: Mar 25, 2010
+ *      Author: crueger
+ */
+
+#ifndef ACTIONHISTORY_HPP_
+#define ACTIONHISTORY_HPP_
+
+#include "Patterns/Singleton.hpp"
+
+#include <deque>
+
+#include "Actions/Action.hpp"
+
+
+class ActionHistory : public Singleton<ActionHistory,false>
+{
+  friend class Singleton<ActionHistory,false>;
+
+  struct HistoryElement {
+    HistoryElement(Action *_action, Action::state_ptr _state) :
+      action(_action),
+      state(_state)
+    {}
+    Action *action;
+    Action::state_ptr state;
+  };
+
+  class UndoAction : public Action {
+  public:
+    UndoAction(ActionHistory*);
+    virtual ~UndoAction();
+
+    virtual bool canUndo();
+    virtual bool shouldUndo();
+
+    virtual bool isActive();
+
+  private:
+    virtual Action::state_ptr performCall();
+    virtual Action::state_ptr performUndo(Action::state_ptr);
+    virtual Action::state_ptr performRedo(Action::state_ptr);
+
+    ActionHistory *hist;
+  };
+
+  class RedoAction : public Action {
+  public:
+    RedoAction(ActionHistory*);
+    virtual ~RedoAction();
+
+    virtual bool canUndo();
+    virtual bool shouldUndo();
+
+    virtual bool isActive();
+
+  private:
+    virtual Action::state_ptr performCall();
+    virtual Action::state_ptr performUndo(Action::state_ptr);
+    virtual Action::state_ptr performRedo(Action::state_ptr);
+
+    ActionHistory *hist;
+  };
+
+public:
+
+  void undoLast();
+  void redoLast();
+
+  bool hasUndo();
+  bool hasRedo();
+
+  void addElement(Action*,Action::state_ptr);
+  void clear();
+protected:
+  ActionHistory();
+  virtual ~ActionHistory();
+private:
+  std::deque<HistoryElement> history;
+  std::deque<HistoryElement> yrotsih;
+
+public:
+  // when constructing the actions we need the Actionregistry Singleton
+  // Singletons need static variables to work, but we cannot access statics
+  // inside a static initialization, so we have this init function that
+  // needs to be called at a non-static point at the start of the program
+  static void init();
+};
+
+#endif /* ACTIONHISTORY_HPP_ */
Index: src/Actions/ActionRegistry.cpp
===================================================================
--- src/Actions/ActionRegistry.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Actions/ActionRegistry.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -9,11 +9,11 @@
 #include "Actions/Action.hpp"
 
+#include "Patterns/Singleton_impl.hpp"
+
 #include <string>
-#include <cassert>
+#include "Helpers/Assert.hpp"
 #include <iostream>
 
 using namespace std;
-
-ActionRegistry *ActionRegistry::theInstance=0;
 
 ActionRegistry::ActionRegistry()
@@ -24,8 +24,8 @@
 {
   map<const string,Action*>::iterator iter;
-  for(iter=actionMap.begin();iter!=actionMap.end();iter++) {
+  for(iter=actionMap.begin();iter!=actionMap.end();++iter) {
     delete iter->second;
-    actionMap.erase(iter);
   }
+  actionMap.clear();
 }
 
@@ -33,5 +33,5 @@
   map<const string,Action*>::iterator iter;
   iter = actionMap.find(name);
-  assert(iter!=actionMap.end() && "Query for an action not stored in registry");
+  ASSERT(iter!=actionMap.end(),"Query for an action not stored in registry");
   return iter->second;
 }
@@ -40,19 +40,16 @@
   pair<map<const string,Action*>::iterator,bool> ret;
   ret = actionMap.insert(pair<const string,Action*>(action->getName(),action));
-  assert(ret.second && "Two actions with the same name added to registry");
+  ASSERT(ret.second,"Two actions with the same name added to registry");
 }
 
-// singleton stuff
-ActionRegistry* ActionRegistry::getRegistry(){
-  if(!theInstance){
-    theInstance = new ActionRegistry();
-  }
-  return theInstance;
+std::map<const std::string,Action*>::iterator ActionRegistry::getBeginIter()
+{
+  return actionMap.begin();
 }
 
-void ActionRegistry::purgeRegistry(){
-  if(theInstance){
-    delete theInstance;
-    theInstance = 0;
-  }
+std::map<const std::string,Action*>::iterator ActionRegistry::getEndIter()
+{
+  return actionMap.end();
 }
+
+CONSTRUCT_SINGLETON(ActionRegistry)
Index: src/Actions/ActionRegistry.hpp
===================================================================
--- src/Actions/ActionRegistry.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Actions/ActionRegistry.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -12,23 +12,24 @@
 #include <map>
 
+#include "Patterns/Singleton.hpp"
+
 class Action;
 
-class ActionRegistry
+class ActionRegistry : public Singleton<ActionRegistry>
 {
+  friend class Singleton<ActionRegistry>;
 public:
   Action* getActionByName(const std::string);
   void registerAction(Action*);
 
+  std::map<const std::string,Action*>::iterator getBeginIter();
+  std::map<const std::string,Action*>::iterator getEndIter();
+
 private:
   std::map<const std::string,Action*> actionMap;
 
-// singleton stuff
-public:
-  static ActionRegistry* getRegistry();
-  static void purgeRegistry();
 private:
   ActionRegistry();
   virtual ~ActionRegistry();
-  static ActionRegistry *theInstance;
 };
 
